	(*************************************************)
	(*                                               *)
	(*  Modul Strophen				 *)
	(*  Programmiert von Ralph Wilks und A. Schmidt  *)
	(*  Aktueller Stand  : 13. 6 1989                *)
	(*                                               *)
	(*  Version 2.1                                  *)
	(*  "manisch-depressive" Gedichte	         *)
	(*                                               *)
	(*************************************************)

(* Anzupassen: Operationen zum selbstverwalteten I/O-Check. Vorliegende *)
(* Version luft unter ST Pascal+             				*)

   VAR
	  DatTitel,                 (* logische Dateinamen *)
	  DatAngst,
	  Datvieles,
	  Datstoerend,
	  Datlauernd,
	  Datunter,
	  Datroten,
	  DatSonnen,
	  Datich_bin,
	  Datallein,
	  DatGedanken,
	  Datsuchen,
	  DatHilfe,
	  ausgabe
			  : text;

	  FTitel                (* Dateien als Felder im Arbeitsspeicher *)
			  : ARRAY [1..maxDateiEintraege] OF string40;
	  FAngst,
	  Fvieles,
	  Fstoerend,
	  Flauernd,
	  Funter,
	  Froten,
	  FSonnen,
	  Fich_bin,
	  Fallein,
	  FGedanken,
	  Fsuchen,
	  FHilfe
			  : ARRAY [1..maxDateiEintraege] OF string20;
	  AnzTitel,
	  AnzAngst,
	  Anzvieles,
	  Anzstoerend,
	  Anzlauernd,
	  Anzunter,
	  Anzroten,
	  AnzSonnen,
	  Anzich_bin,
	  Anzallein,
	  AnzGedanken,
	  Anzsuchen,
	  AnzHilfe
			  : 0..maxDateiEintraege;

	  Wort
			  : string40;


   PROCEDURE init ( VAR ok: boolean );
      (* Initialisiert den Datenmodul, liest alle Dateien ein. Gibt        *)
      (* ok=TRUE zurueck, wenn erfolgreich, sonst ok=FALSE.                *)
   VAR
       zaehler : 0..maxDateiEintraege;
   BEGIN
     ok := TRUE;
     IO_Check (FALSE);
     reset (DatTitel, titeldat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
	THEN BEGIN
	    AnzTitel := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatTitel)
	       THEN BEGIN
 	         readln (DatTitel, FTitel [zaehler]);
		 AnzTitel := AnzTitel + 1;
		 END
	       ELSE
		 FTitel[zaehler] := ' ';
            END;
     close (DatTitel);
     reset (DatAngst, angstdat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
	THEN BEGIN
	    AnzAngst := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatAngst)
	       THEN
		    BEGIN
		      readln (DatAngst, FAngst [zaehler]);
		      AnzAngst := AnzAngst + 1;
		    END
	       ELSE
		    FAngst[zaehler] := ' ';
            END;
     close (DatAngst);
     reset (Datvieles, vielesdat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
	THEN BEGIN
	    Anzvieles := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(Datvieles)
	       THEN BEGIN
	         readln (Datvieles, Fvieles [zaehler]);
	         Anzvieles := Anzvieles + 1;
	         END
	       ELSE
	         Fvieles [zaehler] := ' ';
	    END;
     close (Datvieles);
     reset (Datstoerend, stoerenddat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
	THEN BEGIN
	    Anzstoerend := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(Datstoerend)
	       THEN BEGIN
                 readln (Datstoerend, Fstoerend [zaehler]);
		 Anzstoerend := Anzstoerend + 1;
		 END
	       ELSE
		 Fstoerend [zaehler] := ' ';
            END;
     close (Datstoerend);
     reset (Datlauernd, lauernddat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
	THEN BEGIN
	    Anzlauernd := 0;
	    FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(Datlauernd)
	       THEN BEGIN
                 readln (Datlauernd, Flauernd [zaehler]);
		 Anzlauernd := Anzlauernd + 1;
		 END
	       ELSE
		 Flauernd [zaehler] := ' ';
	    END;
     close (Datlauernd); 
     reset (Datunter, unterdat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
         Anzunter := 0;
         FOR zaehler := 1 TO maxDateiEintraege DO
 	    IF NOT eof(Datunter)
	       THEN BEGIN
	         readln (Datunter, Funter [zaehler]);
	         Anzunter := Anzunter + 1;
	         END
	       ELSE
	         Funter [zaehler] := ' ';
         END;
     close (Datunter);
     reset (Datroten, rotendat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
 	 Anzroten := 0;
	 FOR zaehler := 1 TO maxDateiEintraege DO
	   IF NOT eof(Datroten)
	     THEN BEGIN
	       readln (Datroten, Froten [zaehler]);
	       Anzroten := Anzroten + 1;
	       END
	     ELSE
	       Froten [zaehler] := ' ';
         END;
     close (Datroten);
     reset (DatSonnen, sonnendat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	 AnzSonnen := 0;
	 FOR zaehler := 1 TO maxDateiEintraege DO
	   IF NOT eof(DatSonnen)
	     THEN BEGIN
	       readln (DatSonnen, FSonnen [zaehler]);
	       AnzSonnen := AnzSonnen + 1;
	       END
	     ELSE
	       FSonnen [zaehler] := ' ';
         END;
     close (DatSonnen);
     reset (Datich_bin, ich_bindat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	  Anzich_bin := 0;
	  FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(Datich_bin)
	      THEN BEGIN
		readln (Datich_bin, Fich_bin [zaehler]);
		Anzich_bin := Anzich_bin + 1;
		END
	      ELSE
		Fich_bin [zaehler] := ' ';
        END;
     close (Datich_bin);
     reset (Datallein, alleindat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	  Anzallein := 0;
	  FOR zaehler := 1 TO maxDateiEintraege DO
	  IF NOT eof(Datallein)
	    THEN BEGIN
	      readln (Datallein, Fallein [zaehler]);
	      Anzallein := Anzallein + 1;
	      END
	    ELSE
	      Fallein [zaehler] := ' ';
        END;
     close (Datallein);
     reset (DatGedanken, gedankendat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok 
       THEN BEGIN
	  AnzGedanken := 0;
	  FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatGedanken)
	     THEN BEGIN
               readln (DatGedanken, FGedanken [zaehler]);
	       AnzGedanken := AnzGedanken + 1;
	       END
	     ELSE
	       FGedanken [zaehler] := ' ';
          END;
     close (DatGedanken);
     reset (Datsuchen, suchendat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	 Anzsuchen := 0;
	 FOR zaehler := 1 TO maxDateiEintraege DO
	   IF NOT eof(Datsuchen)
	     THEN BEGIN
	       readln (Datsuchen, Fsuchen [zaehler]);
	       Anzsuchen := Anzsuchen + 1;
	       END
	     ELSE
	       Fsuchen [zaehler] := ' ';
         END;
     close (Datsuchen);
     reset (DatHilfe, hilfedat);
     IF IO_Result <> 0
	THEN ok := FALSE;
     IF ok
       THEN BEGIN
	  AnzHilfe := 0;
	  FOR zaehler := 1 TO maxDateiEintraege DO
	    IF NOT eof(DatHilfe)
	       THEN BEGIN
		 readln (DatHilfe, FHilfe [zaehler]);
		 AnzHilfe := AnzHilfe + 1;
		 END
	       ELSE
		 FHilfe [zaehler] := ' ';
	  END; (* then *)
     CLOSE (DatHilfe);       
     IO_Check (TRUE);
     initgrand;
     rewrite (ausgabe, ausgabedatei);
   END;  (* init *)

(************************************************************************)

   PROCEDURE baueStrophe ( VAR str: tStrophe );
      (* Baut eine Strophe aus den Grunddateien zusammen und uebergibt sie *)
      (* als str.                                                          *)
     VAR zufzahl : integer;

     BEGIN  (* baueStrophe *)
       mein_random (AnzAngst, zufzahl);
       str[1] := FAngst[zufzahl];
       zentriere (str[1]);
       mein_random (Anzvieles, zufzahl);
       str[2] := Fvieles[zufzahl];
       mein_random (Anzstoerend, zufzahl);
       str[2] := concat (str[2], ' ', Fstoerend[zufzahl]);
       zentriere (str[2]);
       mein_random (AnzAngst, zufzahl);
       str[3] := FAngst[zufzahl];
       zentriere (str[3]);
       mein_random (Anzlauernd, zufzahl);
       str[4] := Flauernd[zufzahl];
       mein_random (Anzunter, zufzahl);
       str[4] := concat (str[4], ' ', Funter[zufzahl]);
       mein_random (Anzroten, zufzahl);
       str[4] := concat (str[4], ' ', Froten[zufzahl]);
       mein_random (AnzSonnen, zufzahl);
       str[4] := concat (str[4], ' ', FSonnen[zufzahl]);
       zentriere (str[4]);
       mein_random (Anzich_bin, zufzahl);
       str[5] := Fich_bin[zufzahl];
       mein_random (Anzallein, zufzahl);
       str[5] := concat (str[5], ' ', Fallein[zufzahl]);
       zentriere (str[5]);
       mein_random (AnzGedanken, zufzahl);
       str[6] := FGedanken[zufzahl];
       mein_random (Anzsuchen, zufzahl);
       str[6] := concat (str[6], ' ', Fsuchen[zufzahl]);
       mein_random (AnzHilfe, zufzahl);
       str[6] := concat (str[6], ' ', FHilfe[zufzahl]);
       zentriere (str[6]);
     END;  (* baueStrophe *)

(************************************************************************)

   PROCEDURE baueTitel ( VAR titel: tTitel );
     VAR zufzahl : integer;
	 zaehler : integer;

     BEGIN
       mein_random (AnzTitel, zufzahl);
       titel[1] := FTitel[zufzahl];
       titel[2] := '=';
       FOR zaehler := 2 TO length (titel[1]) DO
       titel[2] := concat (titel[2], '=');
       zentriere (titel[1]);
       zentriere (titel[2]);
       titel[3] := ' ';
     END;

(************************************************************************)

   PROCEDURE spTitel ( titel: tTitel );
     VAR zaehler : 1..2;

     BEGIN
       writeln (ausgabe);
       writeln (ausgabe);
       FOR zaehler := 1 TO 2 DO
	   writeln (ausgabe, titel [zaehler]);
     END;

(************************************************************************)

   PROCEDURE speichereStrophe ( str: tStrophe );
     VAR zaehler : 1..6;     (* Anzahl der Verse ist 6 *)

     BEGIN
       writeln (ausgabe);
       FOR zaehler := 1 TO 6 DO
	   writeln (ausgabe, str[zaehler]);
     END;  (* speichereStrophe *)

(************************************************************************)

   PROCEDURE zeigeTitel ( titel: tTitel );
     VAR zaehler : 1..2;

     BEGIN
       cur_off;
       FOR zaehler := 1 TO 2 DO
	   writeln (titel[zaehler]);
       cur_on;
     END;


(************************************************************************)

   PROCEDURE zeigeStrophe ( str: tStrophe );
      (* zeigt eine Strophe mit fuehrender und nachfolgender Leerzeile     *)
      (* auf dem Bildschirm                                                *)
     VAR zaehler : 1..6;     (* Anzahl der Verse ist 6 *)
     BEGIN
       Cur_off;
       writeln;
       FOR zaehler := 1 TO 6 DO
	   writeln (str[zaehler]);
       Cur_on;
     END;  (* zeigeStrophe *)

(************************************************************************)

   PROCEDURE schliesse;
      (* Schliesst alle geoeffneten Dateien *)
      (* Unter Turbo eher nicht zu gebrauchen, da drfen nicht so viele *)
      (* Dateien gleichzeitig geffnet sein. *)
     BEGIN
       close ( DatAngst );
       close ( Datvieles );
       close ( Datstoerend );
       close ( Datlauernd );
       close ( Datunter );
       close ( Datroten );
       close ( DatSonnen );
       close ( Datich_bin );
       close ( Datallein );
       close ( DatGedanken );
       close ( Datsuchen );
       close ( DatHilfe );
       close ( ausgabe );
     END; (* schliesse *)

